@using Entities
@using Business
@using DataAccess

@inject IDbContextFactory<inventory_context> ContextFactory
@inject NavigationManager navManager

@if (DataLoading)
{
    <h4>@loading_message</h4>
}

<div>
    <EditForm Model="oWarehouse">
        <div>
            <label for="">Nombre de la Bodega:</label>
            <InputText class="form-control" @bind-Value="oWarehouse.WarehouseName" />
        </div>
        <br>
        
        <div>
            <label for="">Direccion de la Bodega:</label>
            <InputText class="form-control" @bind-Value="oWarehouse.WarehouseAddress" />
        </div>
        <br>

        <input type="button" value="Actualizar Bodega" @onclick="UpdateWarehouse">
    </EditForm>
</div>


@code
{
    [Parameter] public int ParamWarehouseId {get; set;}
    private bool DataLoading = false;
    private string loading_message = "Fetching Warehouse Info ...";

    Warehouse oWarehouse = new ();

    B_Warehouse bWarehouse = null!;

    protected override async Task OnInitializedAsync()
    {
        if (DataLoading)
        {
            return;
        }

        try
        {
            DataLoading = true;
            bWarehouse = new(ContextFactory);
            oWarehouse = await bWarehouse.GetWarehouseById(ParamWarehouseId);
        }
        catch (System.Exception ex)
        {
            throw ex;
        }
        finally
        {
            DataLoading = false;
        }
        
        
        await base.OnInitializedAsync();
    }

    private async Task UpdateWarehouse()
    {
        if (bWarehouse is not null)
        {
            await bWarehouse.UpdateWarehouse(oWarehouse);
            oWarehouse = new();
            navManager.NavigateTo("warehouse/list");

        }
    }

    
}